blob: 2164ad79a72b42868bb4da0909f8cecd0b88fb0e [file] [log] [blame]
Tom Rinid2244b92019-06-19 09:25:17 -04001# SPDX-License-Identifier: GPL-2.0+
2
Peter Hoyesb0722af2023-03-10 09:53:02 +00003variables:
4 DEFAULT_TAG: ""
Peter Hoyes08ed84e2023-03-10 09:53:03 +00005 MIRROR_DOCKER: docker.io
Simon Glass42f0dd02024-11-12 07:13:26 -07006 SJG_LAB: ""
Peter Hoyesb0722af2023-03-10 09:53:02 +00007
8default:
9 tags:
10 - ${DEFAULT_TAG}
11
Joel Stanleyb97c1d42022-08-23 16:18:26 +100012# Grab our configured image. The source for this is found
13# in the u-boot tree at tools/docker/Dockerfile
Tom Rinie0c84c82024-08-21 09:41:20 -060014image: ${MIRROR_DOCKER}/trini/u-boot-gitlab-ci-runner:jammy-20240808-21Aug2024
Tom Rinid2244b92019-06-19 09:25:17 -040015
16# We run some tests in different order, to catch some failures quicker.
17stages:
Tom Rinid2244b92019-06-19 09:25:17 -040018 - testsuites
Tom Rini1cdb1822019-07-24 13:09:31 -040019 - test.py
Simon Glass42f0dd02024-11-12 07:13:26 -070020 - sjg-lab
Tom Rinid2244b92019-06-19 09:25:17 -040021 - world build
22
23.buildman_and_testpy_template: &buildman_and_testpy_dfn
Tom Rinid2244b92019-06-19 09:25:17 -040024 stage: test.py
Tom Rini6acc0192023-07-11 22:33:03 -040025 retry: 2 # QEMU may be too slow, etc.
Andrejs Cainikovsb4453552023-09-13 16:15:36 +020026 rules:
27 - when: always
Tom Rinid2244b92019-06-19 09:25:17 -040028 before_script:
29 # Clone uboot-test-hooks
Tom Rinie0f979b2022-11-21 12:52:40 -050030 - git config --global --add safe.directory "${CI_PROJECT_DIR}"
Tom Rini2a1df582021-02-24 17:05:04 -050031 - git clone --depth=1 https://source.denx.de/u-boot/u-boot-test-hooks /tmp/uboot-test-hooks
Jerome Forissierde134d92024-10-16 12:04:14 +020032 # qemu_arm64_lwip_defconfig is the same as qemu_arm64 but with NET_LWIP enabled.
33 # The test config and the boardenv file from qemu_arm64 can be re-used so create symlinks
34 - ln -s conf.qemu_arm64_na /tmp/uboot-test-hooks/bin/travis-ci/conf.qemu_arm64_lwip_na
Tom Rinid2244b92019-06-19 09:25:17 -040035 - ln -s travis-ci /tmp/uboot-test-hooks/bin/`hostname`
36 - ln -s travis-ci /tmp/uboot-test-hooks/py/`hostname`
Tom Rini6ad26042019-10-04 12:12:54 -040037 - grub-mkimage --prefix="" -o ~/grub_x86.efi -O i386-efi normal echo lsefimmap lsefi lsefisystab efinet tftp minicmd
38 - grub-mkimage --prefix="" -o ~/grub_x64.efi -O x86_64-efi normal echo lsefimmap lsefi lsefisystab efinet tftp minicmd
Bin Mengb68d9d62020-03-28 07:25:29 -070039 - if [[ "${TEST_PY_BD}" == "qemu-riscv32_spl" ]]; then
Heinrich Schuchardt29999e42023-10-25 00:15:43 +020040 wget -O - https://github.com/riscv-software-src/opensbi/releases/download/v1.3.1/opensbi-1.3.1-rv-bin.tar.xz | tar -C /tmp -xJ;
41 export OPENSBI=/tmp/opensbi-1.3.1-rv-bin/share/opensbi/ilp32/generic/firmware/fw_dynamic.bin;
Bin Mengb68d9d62020-03-28 07:25:29 -070042 fi
Bin Meng0ae41062021-08-26 23:33:35 +080043 - if [[ "${TEST_PY_BD}" == "qemu-riscv64_spl" ]] || [[ "${TEST_PY_BD}" == "sifive_unleashed" ]]; then
Heinrich Schuchardt29999e42023-10-25 00:15:43 +020044 wget -O - https://github.com/riscv-software-src/opensbi/releases/download/v1.3.1/opensbi-1.3.1-rv-bin.tar.xz | tar -C /tmp -xJ;
45 export OPENSBI=/tmp/opensbi-1.3.1-rv-bin/share/opensbi/lp64/generic/firmware/fw_dynamic.bin;
Bin Mengb68d9d62020-03-28 07:25:29 -070046 fi
Patrick Rudolphd67a7422024-10-23 15:20:20 +020047 - if [[ "${TEST_PY_BD}" == "qemu-arm-sbsa" ]]; then
48 wget -O /tmp/bl1.bin https://artifacts.codelinaro.org/artifactory/linaro-419-sbsa-ref/latest/tf-a/bl1.bin;
49 wget -O /tmp/fip.bin https://artifacts.codelinaro.org/artifactory/linaro-419-sbsa-ref/latest/tf-a/fip.bin;
Tom Rini8fa34f02024-10-27 17:14:22 -060050 export BINMAN_INDIRS=/tmp;
Patrick Rudolphd67a7422024-10-23 15:20:20 +020051 fi
Tom Rini1cdb1822019-07-24 13:09:31 -040052
Tom Rinid2244b92019-06-19 09:25:17 -040053 after_script:
Tom Rini792dbc32024-06-27 07:43:20 -060054 - cp -v /tmp/${TEST_PY_BD}/*.{html,css,xml} .
Heinrich Schuchardt159b0ab2019-12-19 13:30:32 +010055 - rm -rf /tmp/uboot-test-hooks /tmp/venv
Tom Rinid2244b92019-06-19 09:25:17 -040056 script:
Simon Glassda499352020-03-18 09:42:57 -060057 # If we've been asked to use clang only do one configuration.
Simon Glass28d83e72020-03-18 09:42:55 -060058 - export UBOOT_TRAVIS_BUILD_DIR=/tmp/${TEST_PY_BD}
Simon Glass2e32f5d2022-08-03 12:13:09 -060059 - echo BUILD_ENV ${BUILD_ENV}
Simon Glassc2f01902023-01-15 14:16:00 -070060 - if [ -n "${BUILD_ENV}" ]; then
61 export ${BUILD_ENV};
62 fi
Simon Glass87c80462020-03-18 09:43:00 -060063 - tools/buildman/buildman -o ${UBOOT_TRAVIS_BUILD_DIR} -w -E -W -e
64 --board ${TEST_PY_BD} ${OVERRIDE}
Heinrich Schuchardtba0ae212020-07-14 00:23:58 +020065 - cp ~/grub_x86.efi $UBOOT_TRAVIS_BUILD_DIR/
66 - cp ~/grub_x64.efi $UBOOT_TRAVIS_BUILD_DIR/
67 - cp /opt/grub/grubriscv64.efi $UBOOT_TRAVIS_BUILD_DIR/grub_riscv64.efi
Heinrich Schuchardtba0ae212020-07-14 00:23:58 +020068 - cp /opt/grub/grubaa64.efi $UBOOT_TRAVIS_BUILD_DIR/grub_arm64.efi
69 - cp /opt/grub/grubarm.efi $UBOOT_TRAVIS_BUILD_DIR/grub_arm.efi
Bin Meng0ae41062021-08-26 23:33:35 +080070 # create sdcard / spi-nor images for sifive unleashed using genimage
71 - if [[ "${TEST_PY_BD}" == "sifive_unleashed" ]]; then
72 mkdir -p root;
73 cp ${UBOOT_TRAVIS_BUILD_DIR}/spl/u-boot-spl.bin .;
74 cp ${UBOOT_TRAVIS_BUILD_DIR}/u-boot.itb .;
75 rm -rf tmp;
76 genimage --inputpath . --config board/sifive/unleashed/genimage_sdcard.cfg;
77 cp images/sdcard.img ${UBOOT_TRAVIS_BUILD_DIR}/;
78 rm -rf tmp;
79 genimage --inputpath . --config board/sifive/unleashed/genimage_spi-nor.cfg;
80 cp images/spi-nor.img ${UBOOT_TRAVIS_BUILD_DIR}/;
81 fi
Simon Glass13e1fa02022-01-21 10:23:01 -070082 - if [[ "${TEST_PY_BD}" == "coreboot" ]]; then
Tom Rinid0296f62024-02-13 09:39:27 -050083 cp /opt/coreboot/coreboot.rom ${UBOOT_TRAVIS_BUILD_DIR}/coreboot.rom;
84 /opt/coreboot/cbfstool ${UBOOT_TRAVIS_BUILD_DIR}/coreboot.rom remove -n fallback/payload;
85 /opt/coreboot/cbfstool ${UBOOT_TRAVIS_BUILD_DIR}/coreboot.rom add-flat-binary -f ${UBOOT_TRAVIS_BUILD_DIR}/u-boot.bin -n fallback/payload -c LZMA -l 0x1110000 -e 0x1110000;
Simon Glass13e1fa02022-01-21 10:23:01 -070086 fi
Tom Riniebcd2142019-10-24 11:59:27 -040087 - virtualenv -p /usr/bin/python3 /tmp/venv
88 - . /tmp/venv/bin/activate
89 - pip install -r test/py/requirements.txt
Simon Glass2600f7e2020-03-18 09:42:56 -060090 # "${var:+"-k $var"}" expands to "" if $var is empty, "-k $var" if not
Simon Glass28d83e72020-03-18 09:42:55 -060091 - export PATH=/opt/qemu/bin:/tmp/uboot-test-hooks/bin:${PATH};
Tom Rinid2244b92019-06-19 09:25:17 -040092 export PYTHONPATH=/tmp/uboot-test-hooks/py/travis-ci;
Heinrich Schuchardt2a3ec0a2020-07-10 22:04:40 +020093 ./test/py/test.py -ra --bd ${TEST_PY_BD} ${TEST_PY_ID}
Simon Glass2600f7e2020-03-18 09:42:56 -060094 ${TEST_PY_TEST_SPEC:+"-k ${TEST_PY_TEST_SPEC}"}
Simon Glassfd0c59b2020-03-18 09:42:59 -060095 --build-dir "$UBOOT_TRAVIS_BUILD_DIR"
Tom Rini792dbc32024-06-27 07:43:20 -060096 --junitxml=/tmp/${TEST_PY_BD}/results.xml
Marek Vasutc1a44de2023-03-03 02:22:25 +010097 artifacts:
98 when: always
99 paths:
100 - "*.html"
101 - "*.css"
Tom Rini792dbc32024-06-27 07:43:20 -0600102 reports:
103 junit: results.xml
Marek Vasutc1a44de2023-03-03 02:22:25 +0100104 expire_in: 1 week
Tom Rinid2244b92019-06-19 09:25:17 -0400105
Andrejs Cainikovsb4453552023-09-13 16:15:36 +0200106.world_build:
Tom Rinid2244b92019-06-19 09:25:17 -0400107 stage: world build
Andrejs Cainikovsb4453552023-09-13 16:15:36 +0200108 rules:
109 - when: always
110
111build all 32bit ARM platforms:
112 extends: .world_build
Tom Rinid2244b92019-06-19 09:25:17 -0400113 script:
114 - ret=0;
Tom Rinie0f979b2022-11-21 12:52:40 -0500115 git config --global --add safe.directory "${CI_PROJECT_DIR}";
Tom Rini95f1c6cb2023-07-22 00:14:46 +0530116 pip install -r tools/buildman/requirements.txt;
Tom Rini93ebd462022-11-09 19:14:53 -0700117 ./tools/buildman/buildman -o /tmp -PEWM arm -x aarch64 || ret=$?;
Simon Glassda499352020-03-18 09:42:57 -0600118 if [[ $ret -ne 0 ]]; then
Simon Glassad8eaed2020-03-18 09:42:53 -0600119 ./tools/buildman/buildman -o /tmp -seP;
Tom Rini70c63a52019-10-24 11:59:16 -0400120 exit $ret;
121 fi;
Tom Rini372c6972019-07-17 17:51:28 -0400122
Heinrich Schuchardt8e8e1cc2019-10-06 12:26:16 +0200123build all 64bit ARM platforms:
Andrejs Cainikovsb4453552023-09-13 16:15:36 +0200124 extends: .world_build
Tom Rini372c6972019-07-17 17:51:28 -0400125 script:
Tom Rini6c883102020-02-11 12:41:14 -0500126 - virtualenv -p /usr/bin/python3 /tmp/venv
Tom Rini7faea832019-07-18 07:28:36 -0400127 - . /tmp/venv/bin/activate
Tom Rini372c6972019-07-17 17:51:28 -0400128 - ret=0;
Tom Rinie0f979b2022-11-21 12:52:40 -0500129 git config --global --add safe.directory "${CI_PROJECT_DIR}";
Tom Rini95f1c6cb2023-07-22 00:14:46 +0530130 pip install -r tools/buildman/requirements.txt;
Tom Rini93ebd462022-11-09 19:14:53 -0700131 ./tools/buildman/buildman -o /tmp -PEWM aarch64 || ret=$?;
Simon Glassda499352020-03-18 09:42:57 -0600132 if [[ $ret -ne 0 ]]; then
Simon Glassad8eaed2020-03-18 09:42:53 -0600133 ./tools/buildman/buildman -o /tmp -seP;
Tom Rini70c63a52019-10-24 11:59:16 -0400134 exit $ret;
135 fi;
Tom Rini372c6972019-07-17 17:51:28 -0400136
Heinrich Schuchardt8e8e1cc2019-10-06 12:26:16 +0200137build all PowerPC platforms:
Andrejs Cainikovsb4453552023-09-13 16:15:36 +0200138 extends: .world_build
Tom Rini372c6972019-07-17 17:51:28 -0400139 script:
140 - ret=0;
Tom Rinie0f979b2022-11-21 12:52:40 -0500141 git config --global --add safe.directory "${CI_PROJECT_DIR}";
Simon Glassda499352020-03-18 09:42:57 -0600142 ./tools/buildman/buildman -o /tmp -P -E -W powerpc || ret=$?;
143 if [[ $ret -ne 0 ]]; then
Simon Glassad8eaed2020-03-18 09:42:53 -0600144 ./tools/buildman/buildman -o /tmp -seP;
Tom Rini70c63a52019-10-24 11:59:16 -0400145 exit $ret;
146 fi;
Tom Rini372c6972019-07-17 17:51:28 -0400147
Heinrich Schuchardt8e8e1cc2019-10-06 12:26:16 +0200148build all other platforms:
Andrejs Cainikovsb4453552023-09-13 16:15:36 +0200149 extends: .world_build
Tom Rini372c6972019-07-17 17:51:28 -0400150 script:
151 - ret=0;
Tom Rinie0f979b2022-11-21 12:52:40 -0500152 git config --global --add safe.directory "${CI_PROJECT_DIR}";
Tom Rini93ebd462022-11-09 19:14:53 -0700153 ./tools/buildman/buildman -o /tmp -PEWM -x arm,powerpc || ret=$?;
Simon Glassda499352020-03-18 09:42:57 -0600154 if [[ $ret -ne 0 ]]; then
Simon Glassad8eaed2020-03-18 09:42:53 -0600155 ./tools/buildman/buildman -o /tmp -seP;
Tom Rini70c63a52019-10-24 11:59:16 -0400156 exit $ret;
157 fi;
Tom Rinid2244b92019-06-19 09:25:17 -0400158
Andrejs Cainikovsb4453552023-09-13 16:15:36 +0200159.testsuites:
Tom Rinibdfa3762021-12-14 13:36:41 -0500160 stage: testsuites
Andrejs Cainikovsb4453552023-09-13 16:15:36 +0200161 rules:
162 - when: always
163
164check for new CONFIG symbols outside Kconfig:
165 extends: .testsuites
Tom Rinibdfa3762021-12-14 13:36:41 -0500166 script:
Tom Rini1cc7e4c2022-12-04 10:14:15 -0500167 - git config --global --add safe.directory "${CI_PROJECT_DIR}"
168 # If grep succeeds and finds a match the test fails as we should
169 # have no matches.
170 - git grep -E '^#[[:blank:]]*(define|undef)[[:blank:]]*CONFIG_'
Tom Rini8f7345c2023-01-10 11:19:46 -0500171 :^doc/ :^arch/arm/dts/ :^scripts/kconfig/lkc.h
Raymond Maodc520542024-10-03 14:50:14 -0700172 :^include/linux/kconfig.h :^tools/ :^dts/upstream/
173 :^lib/mbedtls/external :^lib/mbedtls/mbedtls_def_config.h &&
Sumit Garg8d814682024-02-22 15:05:57 +0530174 exit 1 || exit 0
Tom Rinibdfa3762021-12-14 13:36:41 -0500175
Heinrich Schuchardt54de2412023-01-12 20:30:58 +0100176# build documentation
177docs:
Andrejs Cainikovsb4453552023-09-13 16:15:36 +0200178 extends: .testsuites
Heinrich Schuchardtbccdb652020-02-21 18:24:01 +0100179 script:
Heinrich Schuchardt846abe42021-01-25 22:06:25 +0100180 - virtualenv -p /usr/bin/python3 /tmp/venvhtml
181 - . /tmp/venvhtml/bin/activate
182 - pip install -r doc/sphinx/requirements.txt
Heinrich Schuchardt2e0c8e62023-05-02 05:04:11 +0200183 - make htmldocs KDOC_WERROR=1
Heinrich Schuchardt54de2412023-01-12 20:30:58 +0100184 - make infodocs
Heinrich Schuchardtbccdb652020-02-21 18:24:01 +0100185
Tom Rinid2244b92019-06-19 09:25:17 -0400186# ensure all configs have MAINTAINERS entries
187Check for configs without MAINTAINERS entry:
Andrejs Cainikovsb4453552023-09-13 16:15:36 +0200188 extends: .testsuites
Tom Rinid2244b92019-06-19 09:25:17 -0400189 script:
Tom Rinica00ac62023-10-23 11:37:47 -0400190 - ./tools/buildman/buildman --maintainer-check
Tom Rinid2244b92019-06-19 09:25:17 -0400191
192# Ensure host tools build
Tom Rini8244f002023-08-20 13:31:28 -0400193Build tools-only and envtools:
Andrejs Cainikovsb4453552023-09-13 16:15:36 +0200194 extends: .testsuites
Tom Rinid2244b92019-06-19 09:25:17 -0400195 script:
Tom Rini8244f002023-08-20 13:31:28 -0400196 - make tools-only_config tools-only -j$(nproc);
197 make mrproper;
198 make tools-only_config envtools -j$(nproc)
Pierre-Jean Texier6812f5e2019-08-26 13:06:18 +0200199
Tom Rini0b3e0c42020-03-11 18:11:15 -0400200Run binman, buildman, dtoc, Kconfig and patman testsuites:
Andrejs Cainikovsb4453552023-09-13 16:15:36 +0200201 extends: .testsuites
Tom Rinid2244b92019-06-19 09:25:17 -0400202 script:
Tom Rini0b6e1032019-08-12 10:09:08 -0400203 - git config --global user.name "GitLab CI Runner";
204 git config --global user.email trini@konsulko.com;
Tom Rinid1ed4462022-08-09 21:08:54 -0400205 git config --global --add safe.directory "${CI_PROJECT_DIR}";
Tom Rini0b6e1032019-08-12 10:09:08 -0400206 export USER=gitlab;
Tom Rini6c883102020-02-11 12:41:14 -0500207 virtualenv -p /usr/bin/python3 /tmp/venv;
Tom Rini0b6e1032019-08-12 10:09:08 -0400208 . /tmp/venv/bin/activate;
Tom Rini70c66dd2021-02-26 07:52:29 -0500209 pip install -r test/py/requirements.txt;
Tom Rini95f1c6cb2023-07-22 00:14:46 +0530210 pip install -r tools/buildman/requirements.txt;
Tom Rini08086922023-08-10 12:52:24 -0400211 export UBOOT_TRAVIS_BUILD_DIR=/tmp/tools-only;
Tom Rini0b6e1032019-08-12 10:09:08 -0400212 export PYTHONPATH="${UBOOT_TRAVIS_BUILD_DIR}/scripts/dtc/pylibfdt";
213 export PATH="${UBOOT_TRAVIS_BUILD_DIR}/scripts/dtc:${PATH}";
Tom Rinid1ed4462022-08-09 21:08:54 -0400214 set +e;
Simon Glass492f0b02021-03-15 17:25:34 +1300215 ./tools/buildman/buildman -T0 -o ${UBOOT_TRAVIS_BUILD_DIR} -w
Tom Rini08086922023-08-10 12:52:24 -0400216 --board tools-only;
Tom Rinid1ed4462022-08-09 21:08:54 -0400217 set -e;
Tom Rini0b6e1032019-08-12 10:09:08 -0400218 ./tools/binman/binman --toolpath ${UBOOT_TRAVIS_BUILD_DIR}/tools test;
219 ./tools/buildman/buildman -t;
220 ./tools/dtoc/dtoc -t;
Simon Glass109e84e2020-07-05 21:41:55 -0600221 ./tools/patman/patman test;
Tom Rini0b3e0c42020-03-11 18:11:15 -0400222 make testconfig
Tom Rinid2244b92019-06-19 09:25:17 -0400223
Simon Glassf6903262022-02-11 13:23:26 -0700224# Check for any pylint regressions
225Run pylint:
Andrejs Cainikovsb4453552023-09-13 16:15:36 +0200226 extends: .testsuites
Simon Glassf6903262022-02-11 13:23:26 -0700227 script:
Tom Rinid1ed4462022-08-09 21:08:54 -0400228 - git config --global --add safe.directory "${CI_PROJECT_DIR}"
Simon Glassf6903262022-02-11 13:23:26 -0700229 - pip install -r test/py/requirements.txt
Tom Rini95f1c6cb2023-07-22 00:14:46 +0530230 - pip install -r tools/buildman/requirements.txt
Tom Rini090ff812022-03-25 08:19:09 -0400231 - pip install asteval pylint==2.12.2 pyopenssl
Simon Glassf6903262022-02-11 13:23:26 -0700232 - export PATH=${PATH}:~/.local/bin
233 - echo "[MASTER]" >> .pylintrc
234 - echo "load-plugins=pylint.extensions.docparams" >> .pylintrc
Tom Rini08086922023-08-10 12:52:24 -0400235 - export UBOOT_TRAVIS_BUILD_DIR=/tmp/tools-only
Tom Rinid1ed4462022-08-09 21:08:54 -0400236 - set +e
Simon Glassf6903262022-02-11 13:23:26 -0700237 - ./tools/buildman/buildman -T0 -o ${UBOOT_TRAVIS_BUILD_DIR} -w
Tom Rini08086922023-08-10 12:52:24 -0400238 --board tools-only
Tom Rinid1ed4462022-08-09 21:08:54 -0400239 - set -e
Simon Glassf6903262022-02-11 13:23:26 -0700240 - pylint --version
241 - export PYTHONPATH="${UBOOT_TRAVIS_BUILD_DIR}/scripts/dtc/pylibfdt"
242 - make pylint_err
243
Simon Glassf96763a2023-02-13 08:56:39 -0700244# Check for pre-schema driver model tags
245Check for pre-schema tags:
Andrejs Cainikovsb4453552023-09-13 16:15:36 +0200246 extends: .testsuites
Simon Glassf96763a2023-02-13 08:56:39 -0700247 script:
248 - git config --global --add safe.directory "${CI_PROJECT_DIR}";
249 # If grep succeeds and finds a match the test fails as we should
250 # have no matches.
251 - git grep u-boot,dm- -- '*.dts*' && exit 1 || exit 0
252
Simon Glass5dd13b92023-02-23 18:18:24 -0700253# Check we can package the Python tools
254Check packing of Python tools:
Andrejs Cainikovsb4453552023-09-13 16:15:36 +0200255 extends: .testsuites
Simon Glass5dd13b92023-02-23 18:18:24 -0700256 script:
257 - make pip
258
Tom Rinid2244b92019-06-19 09:25:17 -0400259# Test sandbox with test.py
260sandbox test.py:
Tom Rinid2244b92019-06-19 09:25:17 -0400261 variables:
262 TEST_PY_BD: "sandbox"
Tom Rinid2244b92019-06-19 09:25:17 -0400263 <<: *buildman_and_testpy_dfn
264
Tom Rini99a1bb32019-11-06 19:30:47 -0500265sandbox with clang test.py:
Tom Rini99a1bb32019-11-06 19:30:47 -0500266 variables:
267 TEST_PY_BD: "sandbox"
Tom Rinie752a3a2024-03-10 15:59:28 -0400268 OVERRIDE: "-O clang-17"
Tom Rini99a1bb32019-11-06 19:30:47 -0500269 <<: *buildman_and_testpy_dfn
270
Marek Vasut36bdb592023-09-01 10:48:10 +0200271sandbox64 test.py:
272 variables:
273 TEST_PY_BD: "sandbox64"
274 <<: *buildman_and_testpy_dfn
275
276sandbox64 with clang test.py:
277 variables:
278 TEST_PY_BD: "sandbox64"
Tom Rinie752a3a2024-03-10 15:59:28 -0400279 OVERRIDE: "-O clang-17"
Marek Vasut36bdb592023-09-01 10:48:10 +0200280 <<: *buildman_and_testpy_dfn
281
Tom Rinid2244b92019-06-19 09:25:17 -0400282sandbox_spl test.py:
Tom Rinid2244b92019-06-19 09:25:17 -0400283 variables:
284 TEST_PY_BD: "sandbox_spl"
Simon Glass36a69e12020-10-25 20:38:36 -0600285 TEST_PY_TEST_SPEC: "test_ofplatdata or test_handoff or test_spl"
Tom Rinid2244b92019-06-19 09:25:17 -0400286 <<: *buildman_and_testpy_dfn
287
Simon Glass492f0b02021-03-15 17:25:34 +1300288sandbox_noinst_test.py:
Simon Glass492f0b02021-03-15 17:25:34 +1300289 variables:
290 TEST_PY_BD: "sandbox_noinst"
291 TEST_PY_TEST_SPEC: "test_ofplatdata or test_handoff or test_spl"
292 <<: *buildman_and_testpy_dfn
293
Sean Andersonf65dcc02023-10-14 16:47:59 -0400294sandbox_noinst with LOAD_FIT_FULL test.py:
295 variables:
296 TEST_PY_BD: "sandbox_noinst"
297 TEST_PY_TEST_SPEC: "test_ofplatdata or test_handoff or test_spl"
298 OVERRIDE: "-a CONFIG_SPL_LOAD_FIT_FULL=y"
299 <<: *buildman_and_testpy_dfn
300
Simon Glassa2a4eea2022-04-30 00:56:57 -0600301sandbox_vpl test.py:
302 variables:
303 TEST_PY_BD: "sandbox_vpl"
Simon Glass4e5e7f42023-04-02 14:01:26 +1200304 TEST_PY_TEST_SPEC: "vpl or test_spl"
Simon Glassa2a4eea2022-04-30 00:56:57 -0600305 <<: *buildman_and_testpy_dfn
306
Simon Glassc2f01902023-01-15 14:16:00 -0700307# Enable tracing and disable LTO, to ensure functions are not elided
308sandbox trace_test.py:
309 variables:
310 TEST_PY_BD: "sandbox"
311 BUILD_ENV: "FTRACE=1 NO_LTO=1"
312 TEST_PY_TEST_SPEC: "trace"
Sughosh Ganu0c3783e2023-08-22 23:10:02 +0530313 OVERRIDE: "-a CONFIG_TRACE=y -a CONFIG_TRACE_EARLY=y -a CONFIG_TRACE_EARLY_SIZE=0x01000000 -a CONFIG_TRACE_BUFFER_SIZE=0x02000000"
Simon Glassc2f01902023-01-15 14:16:00 -0700314 <<: *buildman_and_testpy_dfn
315
Tom Rini0008b882019-07-17 16:06:57 -0400316evb-ast2500 test.py:
Tom Rini0008b882019-07-17 16:06:57 -0400317 variables:
318 TEST_PY_BD: "evb-ast2500"
Tom Rini5692b9c2024-10-15 12:28:26 -0600319 TEST_PY_TEST_SPEC: "not sleep"
Tom Rini0008b882019-07-17 16:06:57 -0400320 TEST_PY_ID: "--id qemu"
Tom Rini0008b882019-07-17 16:06:57 -0400321 <<: *buildman_and_testpy_dfn
322
Joel Stanley3f21e1b2022-06-29 16:35:25 +0930323evb-ast2600 test.py:
324 variables:
325 TEST_PY_BD: "evb-ast2600"
Tom Rini5692b9c2024-10-15 12:28:26 -0600326 TEST_PY_TEST_SPEC: "not sleep"
Joel Stanley3f21e1b2022-06-29 16:35:25 +0930327 TEST_PY_ID: "--id qemu"
328 <<: *buildman_and_testpy_dfn
329
Tom Rinid2244b92019-06-19 09:25:17 -0400330sandbox_flattree test.py:
Tom Rinid2244b92019-06-19 09:25:17 -0400331 variables:
332 TEST_PY_BD: "sandbox_flattree"
Tom Rinid2244b92019-06-19 09:25:17 -0400333 <<: *buildman_and_testpy_dfn
334
Kristian Amlie8f8a2992021-09-07 08:37:51 +0200335vexpress_ca9x4 test.py:
336 variables:
337 TEST_PY_BD: "vexpress_ca9x4"
Tom Rini5692b9c2024-10-15 12:28:26 -0600338 TEST_PY_TEST_SPEC: "not sleep"
Kristian Amlie8f8a2992021-09-07 08:37:51 +0200339 TEST_PY_ID: "--id qemu"
340 <<: *buildman_and_testpy_dfn
341
Tom Rinid2244b92019-06-19 09:25:17 -0400342integratorcp_cm926ejs test.py:
Tom Rinid2244b92019-06-19 09:25:17 -0400343 variables:
344 TEST_PY_BD: "integratorcp_cm926ejs"
345 TEST_PY_TEST_SPEC: "not sleep"
346 TEST_PY_ID: "--id qemu"
Tom Rinid2244b92019-06-19 09:25:17 -0400347 <<: *buildman_and_testpy_dfn
348
349qemu_arm test.py:
Tom Rinid2244b92019-06-19 09:25:17 -0400350 variables:
351 TEST_PY_BD: "qemu_arm"
352 TEST_PY_TEST_SPEC: "not sleep"
Tom Rinid2244b92019-06-19 09:25:17 -0400353 <<: *buildman_and_testpy_dfn
354
355qemu_arm64 test.py:
Tom Rinid2244b92019-06-19 09:25:17 -0400356 variables:
357 TEST_PY_BD: "qemu_arm64"
358 TEST_PY_TEST_SPEC: "not sleep"
Tom Rinid2244b92019-06-19 09:25:17 -0400359 <<: *buildman_and_testpy_dfn
360
Jerome Forissierde134d92024-10-16 12:04:14 +0200361qemu_arm64_lwip test.py:
362 variables:
363 TEST_PY_BD: "qemu_arm64_lwip"
364 TEST_PY_TEST_SPEC: "test_net_dhcp or test_net_ping or test_net_tftpboot"
365 <<: *buildman_and_testpy_dfn
366
Patrick Rudolphd67a7422024-10-23 15:20:20 +0200367qemu_arm_sbsa test.py:
368 variables:
369 TEST_PY_BD: "qemu-arm-sbsa"
370 TEST_PY_TEST_SPEC: "not sleep"
371 <<: *buildman_and_testpy_dfn
372
Marek Vasut07240eb2023-03-23 01:22:41 +0100373qemu_m68k test.py:
374 variables:
375 TEST_PY_BD: "M5208EVBE"
376 TEST_PY_ID: "--id qemu"
377 TEST_PY_TEST_SPEC: "not sleep and not efi"
378 OVERRIDE: "-a CONFIG_M68K_QEMU=y -a ~CONFIG_MCFTMR"
379 <<: *buildman_and_testpy_dfn
380
Daniel Schwierzeck744af392020-06-06 22:21:47 +0200381qemu_malta test.py:
Daniel Schwierzeck744af392020-06-06 22:21:47 +0200382 variables:
383 TEST_PY_BD: "malta"
384 TEST_PY_TEST_SPEC: "not sleep and not efi"
385 TEST_PY_ID: "--id qemu"
386 <<: *buildman_and_testpy_dfn
387
388qemu_maltael test.py:
Daniel Schwierzeck744af392020-06-06 22:21:47 +0200389 variables:
390 TEST_PY_BD: "maltael"
391 TEST_PY_TEST_SPEC: "not sleep and not efi"
392 TEST_PY_ID: "--id qemu"
393 <<: *buildman_and_testpy_dfn
394
395qemu_malta64 test.py:
Daniel Schwierzeck744af392020-06-06 22:21:47 +0200396 variables:
397 TEST_PY_BD: "malta64"
398 TEST_PY_TEST_SPEC: "not sleep and not efi"
399 TEST_PY_ID: "--id qemu"
400 <<: *buildman_and_testpy_dfn
401
402qemu_malta64el test.py:
Daniel Schwierzeck744af392020-06-06 22:21:47 +0200403 variables:
404 TEST_PY_BD: "malta64el"
405 TEST_PY_TEST_SPEC: "not sleep and not efi"
406 TEST_PY_ID: "--id qemu"
407 <<: *buildman_and_testpy_dfn
408
Tom Rinid2244b92019-06-19 09:25:17 -0400409qemu-ppce500 test.py:
Tom Rinid2244b92019-06-19 09:25:17 -0400410 variables:
411 TEST_PY_BD: "qemu-ppce500"
412 TEST_PY_TEST_SPEC: "not sleep"
Tom Rinid2244b92019-06-19 09:25:17 -0400413 <<: *buildman_and_testpy_dfn
414
Bin Mengaeb3ea42020-03-28 07:25:27 -0700415qemu-riscv32 test.py:
Bin Mengaeb3ea42020-03-28 07:25:27 -0700416 variables:
417 TEST_PY_BD: "qemu-riscv32"
418 TEST_PY_TEST_SPEC: "not sleep"
Bin Mengaeb3ea42020-03-28 07:25:27 -0700419 <<: *buildman_and_testpy_dfn
420
Tom Rinic8c320e2019-08-02 11:32:37 -0400421qemu-riscv64 test.py:
Tom Rinic8c320e2019-08-02 11:32:37 -0400422 variables:
423 TEST_PY_BD: "qemu-riscv64"
424 TEST_PY_TEST_SPEC: "not sleep"
Tom Rinic8c320e2019-08-02 11:32:37 -0400425 <<: *buildman_and_testpy_dfn
426
Bin Mengb68d9d62020-03-28 07:25:29 -0700427qemu-riscv32_spl test.py:
Bin Mengb68d9d62020-03-28 07:25:29 -0700428 variables:
429 TEST_PY_BD: "qemu-riscv32_spl"
430 TEST_PY_TEST_SPEC: "not sleep"
Bin Mengb68d9d62020-03-28 07:25:29 -0700431 <<: *buildman_and_testpy_dfn
432
433qemu-riscv64_spl test.py:
Bin Mengb68d9d62020-03-28 07:25:29 -0700434 variables:
435 TEST_PY_BD: "qemu-riscv64_spl"
436 TEST_PY_TEST_SPEC: "not sleep"
Bin Mengb68d9d62020-03-28 07:25:29 -0700437 <<: *buildman_and_testpy_dfn
438
Tom Rinid2244b92019-06-19 09:25:17 -0400439qemu-x86 test.py:
Tom Rinid2244b92019-06-19 09:25:17 -0400440 variables:
441 TEST_PY_BD: "qemu-x86"
442 TEST_PY_TEST_SPEC: "not sleep"
Tom Rinid2244b92019-06-19 09:25:17 -0400443 <<: *buildman_and_testpy_dfn
444
445qemu-x86_64 test.py:
Tom Rinid2244b92019-06-19 09:25:17 -0400446 variables:
447 TEST_PY_BD: "qemu-x86_64"
448 TEST_PY_TEST_SPEC: "not sleep"
Tom Rinid2244b92019-06-19 09:25:17 -0400449 <<: *buildman_and_testpy_dfn
450
Jiaxun Yangacc795b2024-06-18 14:56:11 +0100451qemu-xtensa-dc233c test.py:
452 variables:
453 TEST_PY_BD: "qemu-xtensa-dc233c"
454 TEST_PY_TEST_SPEC: "not sleep and not efi"
455 <<: *buildman_and_testpy_dfn
456
Marek Vasutfc5a9d72020-09-14 21:55:58 +0200457r2dplus_i82557c test.py:
Marek Vasutfc5a9d72020-09-14 21:55:58 +0200458 variables:
459 TEST_PY_BD: "r2dplus"
Tom Rini5692b9c2024-10-15 12:28:26 -0600460 TEST_PY_TEST_SPEC: "not sleep"
Marek Vasutfc5a9d72020-09-14 21:55:58 +0200461 TEST_PY_ID: "--id i82557c_qemu"
462 <<: *buildman_and_testpy_dfn
463
464r2dplus_pcnet test.py:
Marek Vasutfc5a9d72020-09-14 21:55:58 +0200465 variables:
466 TEST_PY_BD: "r2dplus"
Tom Rini5692b9c2024-10-15 12:28:26 -0600467 TEST_PY_TEST_SPEC: "not sleep"
Marek Vasutfc5a9d72020-09-14 21:55:58 +0200468 TEST_PY_ID: "--id pcnet_qemu"
469 <<: *buildman_and_testpy_dfn
470
471r2dplus_rtl8139 test.py:
Marek Vasutfc5a9d72020-09-14 21:55:58 +0200472 variables:
473 TEST_PY_BD: "r2dplus"
Tom Rini5692b9c2024-10-15 12:28:26 -0600474 TEST_PY_TEST_SPEC: "not sleep"
Marek Vasutfc5a9d72020-09-14 21:55:58 +0200475 TEST_PY_ID: "--id rtl8139_qemu"
476 <<: *buildman_and_testpy_dfn
477
478r2dplus_tulip test.py:
Marek Vasutfc5a9d72020-09-14 21:55:58 +0200479 variables:
480 TEST_PY_BD: "r2dplus"
Tom Rini5692b9c2024-10-15 12:28:26 -0600481 TEST_PY_TEST_SPEC: "not sleep"
Marek Vasutfc5a9d72020-09-14 21:55:58 +0200482 TEST_PY_ID: "--id tulip_qemu"
483 <<: *buildman_and_testpy_dfn
484
Bin Meng0ae41062021-08-26 23:33:35 +0800485sifive_unleashed_sdcard test.py:
486 variables:
487 TEST_PY_BD: "sifive_unleashed"
Tom Rini5692b9c2024-10-15 12:28:26 -0600488 TEST_PY_TEST_SPEC: "not sleep"
Bin Meng0ae41062021-08-26 23:33:35 +0800489 TEST_PY_ID: "--id sdcard_qemu"
490 <<: *buildman_and_testpy_dfn
491
492sifive_unleashed_spi-nor test.py:
493 variables:
494 TEST_PY_BD: "sifive_unleashed"
Tom Rini5692b9c2024-10-15 12:28:26 -0600495 TEST_PY_TEST_SPEC: "not sleep"
Bin Meng0ae41062021-08-26 23:33:35 +0800496 TEST_PY_ID: "--id spi-nor_qemu"
497 <<: *buildman_and_testpy_dfn
498
Michal Simekf8834fd2020-02-13 15:03:29 +0100499xilinx_zynq_virt test.py:
Tom Rinid2244b92019-06-19 09:25:17 -0400500 variables:
Michal Simekf8834fd2020-02-13 15:03:29 +0100501 TEST_PY_BD: "xilinx_zynq_virt"
Tom Rinid2244b92019-06-19 09:25:17 -0400502 TEST_PY_TEST_SPEC: "not sleep"
Tom Rinid2244b92019-06-19 09:25:17 -0400503 TEST_PY_ID: "--id qemu"
Tom Rinid2244b92019-06-19 09:25:17 -0400504 <<: *buildman_and_testpy_dfn
505
506xilinx_versal_virt test.py:
Tom Rinid2244b92019-06-19 09:25:17 -0400507 variables:
508 TEST_PY_BD: "xilinx_versal_virt"
509 TEST_PY_TEST_SPEC: "not sleep"
Tom Rinid2244b92019-06-19 09:25:17 -0400510 TEST_PY_ID: "--id qemu"
Tom Rinid2244b92019-06-19 09:25:17 -0400511 <<: *buildman_and_testpy_dfn
512
513xtfpga test.py:
Tom Rinid2244b92019-06-19 09:25:17 -0400514 variables:
515 TEST_PY_BD: "xtfpga"
516 TEST_PY_TEST_SPEC: "not sleep"
Tom Rinid2244b92019-06-19 09:25:17 -0400517 TEST_PY_ID: "--id qemu"
Tom Rinid2244b92019-06-19 09:25:17 -0400518 <<: *buildman_and_testpy_dfn
Simon Glass13e1fa02022-01-21 10:23:01 -0700519
520coreboot test.py:
521 variables:
522 TEST_PY_BD: "coreboot"
523 TEST_PY_TEST_SPEC: "not sleep"
524 TEST_PY_ID: "--id qemu"
Simon Glass13e1fa02022-01-21 10:23:01 -0700525 <<: *buildman_and_testpy_dfn
Simon Glass42f0dd02024-11-12 07:13:26 -0700526
527.lab_template: &lab_dfn
528 stage: sjg-lab
529 rules:
530 - if: $SJG_LAB == "1"
531 when: always
Tom Rini06a22342024-11-13 12:05:00 -0600532 - if: $SJG_LAB != "1"
533 when: manual
534 allow_failure: true
Simon Glass42f0dd02024-11-12 07:13:26 -0700535 tags: [ 'lab' ]
536 script:
537 - if [[ -z "${SJG_LAB}" ]]; then
538 exit 0;
539 fi
540 # Environment:
541 # SRC - source tree
542 # OUT - output directory for builds
543 - export SRC="$(pwd)"
544 - export OUT="${SRC}/build/${BOARD}"
545 - export PATH=$PATH:~/bin
546 - export PATH=$PATH:/vid/software/devel/ubtest/u-boot-test-hooks/bin
547
548 # Load it on the device
549 - ret=0
550 - echo "role ${ROLE}"
551 - export strategy="-s uboot -e off"
552 - export USE_LABGRID_SJG=1
553 # export verbose="-v"
554 - ${SRC}/test/py/test.py --role ${ROLE} --build-dir "${OUT}"
555 --capture=tee-sys -k "not bootstd" || ret=$?
556 - U_BOOT_BOARD_IDENTITY="${ROLE}" u-boot-test-release || true
557 - if [[ $ret -ne 0 ]]; then
558 exit $ret;
559 fi
560 artifacts:
561 when: always
562 paths:
563 - "build/${BOARD}/test-log.html"
564 - "build/${BOARD}/multiplexed_log.css"
565 expire_in: 1 week
566
567rpi3:
568 variables:
569 ROLE: rpi3
570 <<: *lab_dfn
571
572opi_pc:
573 variables:
574 ROLE: opi_pc
575 <<: *lab_dfn
576
577pcduino3_nano:
578 variables:
579 ROLE: pcduino3_nano
580 <<: *lab_dfn
581
582samus:
583 variables:
584 ROLE: samus
585 <<: *lab_dfn
586
587link:
588 variables:
589 ROLE: link
590 <<: *lab_dfn
591
592jerry:
593 variables:
594 ROLE: jerry
595 <<: *lab_dfn
596
597minnowmax:
598 variables:
599 ROLE: minnowmax
600 <<: *lab_dfn
601
602opi_pc2:
603 variables:
604 ROLE: opi_pc2
605 <<: *lab_dfn
606
607bpi:
608 variables:
609 ROLE: bpi
610 <<: *lab_dfn
611
612rpi2:
613 variables:
614 ROLE: rpi2
615 <<: *lab_dfn
616
617bob:
618 variables:
619 ROLE: bob
620 <<: *lab_dfn
621
622ff3399:
623 variables:
624 ROLE: ff3399
625 <<: *lab_dfn
626
627coral:
628 variables:
629 ROLE: coral
630 <<: *lab_dfn
631
632rpi3z:
633 variables:
634 ROLE: rpi3z
635 <<: *lab_dfn
636
637bbb:
638 variables:
639 ROLE: bbb
640 <<: *lab_dfn
641
642kevin:
643 variables:
644 ROLE: kevin
645 <<: *lab_dfn
646
647pine64:
648 variables:
649 ROLE: pine64
650 <<: *lab_dfn
651
652c4:
653 variables:
654 ROLE: c4
655 <<: *lab_dfn
656
657rpi4:
658 variables:
659 ROLE: rpi4
660 <<: *lab_dfn
661
662rpi0:
663 variables:
664 ROLE: rpi0
665 <<: *lab_dfn
666
667snow:
668 variables:
669 ROLE: snow
670 <<: *lab_dfn
671
672pcduino3:
673 variables:
674 ROLE: pcduino3
675 <<: *lab_dfn
676
677nyan-big:
678 variables:
679 ROLE: nyan-big
680 <<: *lab_dfn